#ifndef __framerate__
#define __framerate__
//--------------------

#include <windows.h> 
#include <time.h>
class frame_normalizer
{
	
	float NormalFrameRate;
	SYSTEMTIME *prev,*cur;
public:
	long double tm;
	long double am;
	float framerate;
	void set_normal_framerate(float framerate);
	frame_normalizer();
	int check();
};
void frame_normalizer::set_normal_framerate(float framerate)
{
	NormalFrameRate=framerate;

}
frame_normalizer::frame_normalizer()
{
	prev=new SYSTEMTIME;
	cur=new SYSTEMTIME;
	GetSystemTime(prev);

	tm= prev->wMilliseconds+prev->wSecond*1000+prev->wMinute*60*1000;
	NormalFrameRate=60;
}	
int frame_normalizer::check()
{
	long double a,b,c;
	GetSystemTime(cur);
	a=cur->wMilliseconds+(cur->wSecond*1000)+(cur->wMinute*60*1000)+cur->wHour*60*60*1000;
	am=a;
	c=a-tm;
	//c/=60;
	b=NormalFrameRate;
	//-1=
	//1=
	//0=
	if((c-10)<(1000/b))
	{
		framerate=c;
		Sleep((1000/b)-(c-10));
		return 1;
	}
	else if((c+10)>(1000/b))
	{
		prev=cur;
		tm= a;
		framerate=c;
		return -1;
	}
	else 
	{
		prev=cur;
		tm=a;
		framerate=c;
		return 1;
	}

	


}
#endif