#ifndef __HELPERS__
#define __HELPERS__
#include <stdio.h>
#include <iostream>
#include <malloc.h>
#include <string.h>
//*****************************************************************************
//*****************************************************************************
//*** ##   ##  #######  ##       #######    #######     #######    #####    ***
//*** ##   ##  ##       ##       ##    ##   ##          ##    ##  ##   ##   ***
//*** ##   ##  ##       ##       ##    ##   ##          ##    ##  ##        ***
//*** #######  #####    ##       #######    #####       #######    #####    ***
//*** ##   ##  ##       ##       ##         ##          ##  ##         ##   ***
//*** ##   ##  ##       ##       ##         ##          ##   ##   ##   ##   ***
//*** ##   ##  #######  #######  ##         #######     ##    ##   #####    ***
//*****************************************************************************
//*****************************************************************************
void strmoveleft(char *str,int pathlen)
{
	int a=0;
	int b;
	int len;
	while(a<pathlen)
	{
		len=strlen(str);
		b=0;
		while(b<len)
		{
			str[b]=str[b+1];
			b++;
		}
		a++;
		
	}
}
void ltrim(char *str)
{
	int a;

	while(str[0]==' '||str[0]==9)
	{
		a=0;
		while(a<strlen(str))
		{
			str[a]=str[a+1];
			a++;
		}
	}
}
void rtrim(char *str)
{
	int len,a;
	len=strlen(str);
	for(a=len-1;a>=0;a--)
	{
		if(str[a]==' '||str[a]==13||str[a]==10)str[a]='\0';
		else if (str[a]!='\0' && str[a]!=13 && str[a]!=10) break;
	}
}
void killsymb(char *str,char symb)
{
	char *tmp;
	tmp=strchr(str,symb);
	while(tmp!=NULL)
	{
		tmp[0]=' ';
		tmp=strchr(str,symb);
	}
}

//	 
#ifndef PI
#define PI ((float)3.141592654f)
#endif	//	#if !defined PI

//	     
inline float DegToRad(const float f) { return f * PI / 180.0f; }
inline float RadToDeg(const float f) { return f * 180.0f / PI; }
//	    
inline float Sqr(const float f) { return f * f; }
inline float Sqrt(const float f) { return sqrtf(f); }

//	 
struct CVector3 {
	inline CVector3(void): x(0.0f), y(0.0f), z(0.0f) {}
	inline CVector3(const float v): x(v), y(v), z(v) {}
	inline CVector3(const float _x, const float _y, const float _z): x(_x), y(_y), z(_z) {}
	inline ~CVector3(void) { x = y = z = 0.0f; }

	inline const float &operator [](const int i) const { return (&x)[i]; }
	inline float &operator [](const int i) { return (&x)[i]; }
	inline operator const float *(void) const { return &x; }
	inline operator float *(void) { return &x; }

	inline CVector3 operator -(void) const { return CVector3(-x, -y, -z); }
	inline CVector3 operator !(void) const { return CVector3(-x, -y, -z); }
	inline bool operator ==(const CVector3 &v) const { return x == v.x && y == v.y && z == v.z; }
	inline bool operator !=(const CVector3 &v) const { return x != v.x && y != v.y && z != v.z; }
	inline bool operator <(const CVector3 &v) const { return x < v.x && y < v.y && z < v.z; }
	inline bool operator >(const CVector3 &v) const { return x > v.x && y > v.y && z > v.z; }
	inline bool operator <=(const CVector3 &v) const { return x <= v.x && y <= v.y && z <= v.z; }
	inline bool operator >=(const CVector3 &v) const { return x >= v.x && y >= v.y && z >= v.z; }

	inline CVector3 operator +(const CVector3 &v) const { return CVector3(x + v.x, y + v.y, z + v.z); }
	inline CVector3 operator -(const CVector3 &v) const { return CVector3(x - v.x, y - v.y, z - v.z); }
	inline CVector3 operator *(const CVector3 &v) const { return CVector3(x * v.x, y * v.y, z * v.z); }
	inline CVector3 operator /(const CVector3 &v) const { return CVector3(x / v.x, y / v.y, z / v.z); }
	inline CVector3 operator +(const float f) const { return CVector3(x + f, y + f, z + f); }
	inline CVector3 operator -(const float f) const { return CVector3(x - f, y - f, z - f); }
	inline CVector3 operator *(const float f) const { return CVector3(x * f, y * f, z * f); }
	inline CVector3 operator /(const float f) const { return CVector3(x / f, y / f, z / f); }

	inline CVector3 &operator +=(const CVector3 &v) { *this = *this + v; return *this; }
	inline CVector3 &operator -=(const CVector3 &v) { *this = *this - v; return *this; }
	inline CVector3 &operator *=(const CVector3 &v) { *this = *this * v; return *this; }
	inline CVector3 &operator /=(const CVector3 &v) { *this = *this / v; return *this; }
	inline CVector3 &operator +=(const float f) { *this = *this + f; return *this; }
	inline CVector3 &operator -=(const float f) { *this = *this - f; return *this; }
	inline CVector3 &operator *=(const float f) { *this = *this * f; return *this; }
	inline CVector3 &operator /=(const float f) { *this = *this / f; return *this; }

	inline float operator |(const CVector3 &v) const { return x * v.x + y * v.y + z * v.z; }
	inline CVector3 operator ^(const CVector3 &v) const { return CVector3(v.y * z - v.z * y, v.z * x - v.x * z, v.x * y - v.y * x); }

	float x, y, z;
};	//	struct CVector3;

//	      [Min; Max]

//	     [Min; Max]

#endif