#include <windows.h>
#include <stdarg.h>
#include <gl\gl.h>                        //    OpenGL32 
#include <gl\glu.h>                       //    GLu32 
#include <gl\glaux.h>  
class Font
{
	
	GLuint base;
public:
	int first_list;
	int lastlist;
	GLvoid BuildFont(char *fontname,float size,int firstlist,HDC hdc);
	GLvoid KillFont(GLvoid);
	GLvoid glPrint(const char *fmt, float posx, float posy,float posz);

};
GLvoid Font::BuildFont(char *fontname,float size,int firstlist,HDC hdc)  //    
{
  HFONT  font;          
  base = glGenLists(256);  
  font = CreateFont(  -size,0,0,0, FALSE,FALSE,FALSE,FALSE, DEFAULT_CHARSET,OUT_TT_PRECIS,CLIP_DEFAULT_PRECIS,ANTIALIASED_QUALITY,FF_DONTCARE|DEFAULT_PITCH,fontname);    
  SelectObject(hdc, font);       	
  wglUseFontBitmaps(hdc,0,256, firstlist); //  96    
  first_list=firstlist;
  lastlist=firstlist+256;
}

GLvoid Font::KillFont(GLvoid)            //  
{
   glDeleteLists(first_list, 256);        //   96   (  )
}
GLvoid Font::glPrint(const char *fmt, float posx, float posy,float posz)

{ 

  if (fmt == NULL)    return;
  glDisable(GL_BLEND);
  glTranslatef(0.0f,0.0f,posz);
  glRasterPos3f(posx,posy,0);
  glPushAttrib(GL_LIST_BIT);      
  glListBase(first_list);    
  glCallLists(strlen(fmt), GL_UNSIGNED_BYTE,fmt);
  glRasterPos3f(-posx,-posy,0);
  glTranslatef(0.0f,0.0f,-posz);
  glPopAttrib();
  glLoadIdentity();
  glEnable(GL_BLEND);
}
