#include <windows.h>
#include <gl/gl.h>
#include <gl/glaux.h>
#include <gl/glu.h>
#include <math.h>
#include <cstringt.h>
#include <cstringt.h>
#include <atlstr.h>
#include <stdio.h>
#include <time.h>
#include <stdarg.h>
#include <Windowsx.h>
#include <olectl.h>



class textures
{
	int pos;
	
public:
	GLuint texture[999];
	textures();
	int buildtexture(char *szPathName);
	~textures();
	void unload();
};
void textures::unload()
{
	int a;
	for (a=0;a<pos;a++)
	{
		glDeleteTextures(1,&texture[a]);
		texture[a]=NULL;
	}
	pos=0;
}
textures::~textures()
{
	int a;
	for (a=0;a<pos;a++)
	{
		glDeleteTextures(1,&texture[a]);
	}
}
textures::textures()
{
	pos=0;
}
int textures::buildtexture(char *szPathName)
   //       
{
  HDC    hdcTemp;                       // DC  
  HBITMAP    hbmpTemp;					//     
  IPicture  *pPicture;					//  IPicture 
  OLECHAR    wszPath[500];				//     (WCHAR)
  char    szPath[500];					//    
  long    lWidth;						//    
  long    lHeight;						//    
  long    lWidthPixels;					//   
  long    lHeightPixels;				//   
  int a;
  GLint    glMaxTexDim ;				//   
  if (strstr(szPathName, "http://"))	//    http:// ...
  {
    strcpy(szPath, szPathName);			//  PathName  szPath
  }
  else									//    
  {
    GetCurrentDirectory(500, (LPSTR)szPath); //  ,   
//	for(a=1;a<=250;a+=1)
	//{
	//	szPath[a]=szPath[a*2];
	//}
    strcat((char*)szPath, "\\");                  //     \ 
    strcat((char*)szPath, szPathName);            //  PathName
  }

 MultiByteToWideChar(CP_ACP, 0, szPath, -1, wszPath, MAX_PATH);
												    //   
  HRESULT hr = OleLoadPicturePath(wszPath, 0, 0, 0, IID_IPicture, (void**)&pPicture);
  if(FAILED(hr))									//    
  return FALSE;										//  False
  hdcTemp = CreateCompatibleDC(GetDC(0)); //     Windows  
  if(!hdcTemp)										//  , ?
  {													// - :(
    pPicture->Release();							//     IPicture 
    return FALSE;									// 
  }
													//     
  glGetIntegerv(GL_MAX_TEXTURE_SIZE, &glMaxTexDim);
  pPicture->get_Width(&lWidth);						//   
  lWidthPixels  = MulDiv(lWidth, GetDeviceCaps(hdcTemp, LOGPIXELSX), 2540);
  pPicture->get_Height(&lHeight);					//   
  lHeightPixels  = MulDiv(lHeight, GetDeviceCaps(hdcTemp, LOGPIXELSY), 2540);
													//      
  if (lWidthPixels <= glMaxTexDim)
													//       -  
    lWidthPixels = 1 << (int)floor((log((double)lWidthPixels)/log(2.0f)) + 0.5f); 
  else
													//       ,
													//   
    lWidthPixels = glMaxTexDim;
													//      
  if (lHeightPixels <= glMaxTexDim)    lHeightPixels = 1 << (int)floor((log((double)lHeightPixels)/log(2.0f)) + 0.5f);
  else
    lHeightPixels = glMaxTexDim;
														//   
  BITMAPINFO  bi = {0};									//    
  DWORD    *pBits = 0;									//    
  bi.bmiHeader.biSize     = sizeof(BITMAPINFOHEADER);   //  
  bi.bmiHeader.biBitCount = 32; 
  bi.bmiHeader.biWidth    = lWidthPixels;				//    
														//     (   Y)
  bi.bmiHeader.biHeight   = lHeightPixels;
  bi.bmiHeader.biCompression  = BI_RGB;					// RGB 
  bi.bmiHeader.biPlanes    = 1;							// 1  
														//  ,  ,     ,
														//       .
  hbmpTemp = CreateDIBSection (hdcTemp, &bi, DIB_RGB_COLORS, (void**)&pBits, 0, 0);
  if(!hbmpTemp)											// ?
  {                    
    DeleteDC(hdcTemp);									//   
    pPicture->Release();									//     IPicture 
    return FALSE;										//  
  }
														//  !
  SelectObject(hdcTemp, hbmpTemp);						//    
														//     
														//  IPicture  
  pPicture->Render(hdcTemp, 0, 0, lWidthPixels, lHeightPixels, 0, lHeight, lWidth, -lHeight, 0);
														//   BGR  RGB     

  for(long i = 0; i < lWidthPixels * lHeightPixels; i++) //    
  {
    BYTE* pPixel  = (BYTE*)(&pBits[i]);					//   
    BYTE  temp  = pPixel[0];							//      
														// Temp ()
    pPixel[0]  = pPixel[2];								//      (  )
    pPixel[2]  = temp;									//   Temp    (3rd)
	if(pPixel[0]>=(255-25)&&pPixel[0]<=(255+25)&&pPixel[2]>=(255-25)&&pPixel[2]<=(255+25)&&pPixel[1]>=(150-25)&&pPixel[1]<=(150+25))
	{

		pPixel[3]  = 0;
	}
    else pPixel[3]  = 255;								//   alpha =255
  }
  //------------------------------------------------------------
    glGenTextures(1, &texture[pos]);							//   
														//   ,    

  glBindTexture(GL_TEXTURE_2D, texture[pos]);					//    texid

														// (     )

  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_NEAREST);

														// (,    -)  

  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR_MIPMAP_NEAREST);

														// ( -   (  
														//            
														//   ))
														//glTexImage2D(GL_TEXTURE_2D, 0, 4, lWidthPixels, lHeightPixels, 0, GL_RGBA,          GL_UNSIGNED_BYTE, pBits);

  gluBuild2DMipmaps(GL_TEXTURE_2D, 4, lWidthPixels, lHeightPixels,GL_RGBA,GL_UNSIGNED_BYTE, pBits);
  DeleteObject(hbmpTemp);								//  
  DeleteDC(hdcTemp);									//   
  pPicture->Release();									//  IPicture 
  pos++;
  return TRUE;											//   ( )
 
}

//----------------------------------------------------
class TGA_texture
{
public:
	GLubyte  *imageData;                  //   ( 32 )
	GLint    bpp;                         //      
	GLint    width;                       //   
	GLint    height;                      //  
	GLuint    texID;                       // texID   
    TGA_texture();
	~TGA_texture();
	bool LoadTGA(char *filename);
	void unload();
};
TGA_texture::~TGA_texture()
{
	glDeleteTextures(1,&texID);
}
void TGA_texture::unload()
{
			glDeleteTextures(1,&texID);
}
            //  

bool TGA_texture::LoadTGA(char *filename)     //  TGA   
{    
	GLbyte  TGAheader[12]={0,0,2,0,0,0,0,0,0,0,0,0}; //   TGA 
	GLbyte  TGAcompare[12]; //     TGA 
	GLbyte  header[6];      //  6   
	GLuint   bytesPerPixel;  //       TGA 
	GLuint   imageSize;      //  ,      
	GLuint   temp;           //  
	GLuint   type=GL_RGBA;   //     RBGA (32 BPP)
	FILE *file;
	if(file= fopen(filename, "rb"))         //  TGA 
	{
	fread(TGAcompare,1,sizeof(TGAcompare),file);
	fread(header,1,sizeof(header),file);
	
	//   TGA ( *256+ )
    width  = header[1] * 256 + header[0]; 
    //   TGA ( *256+ )
    height = header[3] * 256 + header[2];
	if(width<0)width=-width;
	if(height<0)height=-height;
    if(width  <=0 ||height <=0 ||(header[4]!=24 && header[4]!=32)) 
    {
		fclose(file);                    //  - ,  
		return false;                    //  false
    }
	bpp  = header[4];        //  TGA / (24 or 32)
    bytesPerPixel = bpp/8;   //   8   /  
    //      TGA
    imageSize = width*height*bytesPerPixel;
	imageData=(GLubyte *)calloc(imageSize+5,1); //      TGA 
    fread(imageData, 1, imageSize, file);
	if(imageData==NULL)
	{
	    if(imageData!=NULL)       //    ?
        free(imageData);        //  ,   
	    fclose(file);                      //  
	    return false;                      //  false

	}
	for(GLuint i=0; i<int(imageSize); i+=bytesPerPixel)  //   ,  
    {                                                    //  1  3  ('R'ed  'B'lue)
		temp=imageData[i];                        //    imageData[i]
		imageData[i] = imageData[i + 2]; //  1    3 
		imageData[i + 2] = temp;                  //  3   ,
	}
	fclose (file);                                       //  
    //    
    glGenTextures(1, (GLuint*)&texID);  //  OpenGL  IDs
    glBindTexture(GL_TEXTURE_2D, texID); //   
    //  
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR); 
    //   
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	if (bpp==24)                      //  TGA 24 
    {
	     type=GL_RGB;                            //  'type'  GL_RGB
    }
	glTexImage2D(GL_TEXTURE_2D, 0, type, width, height, 0, type, GL_UNSIGNED_BYTE, imageData);
	return true;              //    Ok,  true
	}
	return false;

}

TGA_texture::TGA_texture()
{
};