#include <windows.h>
#include <gl/gl.h>
#include <gl/glaux.h>
#include <gl/glu.h>
#include <math.h>
#include <cstringt.h>
#include <cstringt.h>
#include <atlstr.h>
#include <stdio.h>
#include <time.h>
#include <stdarg.h>
#include <Windowsx.h>
#include <olectl.h>

class light
{
	GLfloat LightAmbient[4];
	GLfloat LightDiffuse[4];
	GLfloat LightPosition[4];
public:

	void set_ambient(GLfloat r,GLfloat g, GLfloat b,GLfloat a);
	void set_diffuse(GLfloat r,GLfloat g, GLfloat b,GLfloat a);
	void set_pos(GLfloat x,GLfloat y, GLfloat z,GLfloat a);
	void light_init();
	void move_to_pos();
	light();
};
void light::set_ambient(GLfloat r,GLfloat g, GLfloat b,GLfloat a)
{
	LightAmbient[0]=r;
	LightAmbient[1]=g;
	LightAmbient[2]=b;
	LightAmbient[3]=a;
}
void light::set_diffuse(GLfloat r,GLfloat g, GLfloat b,GLfloat a)
{
	LightDiffuse[0]=r;
	LightDiffuse[1]=g;
	LightDiffuse[2]=b;
	LightDiffuse[3]=a;
}
void light::set_pos(GLfloat x,GLfloat y, GLfloat z,GLfloat a)
{
	LightPosition[0]=x;
	LightPosition[1]=y;
	LightPosition[2]=z;
	LightPosition[3]=a;
}
light::light(){};
void light::light_init()
{
	glEnable(GL_AUTO_NORMAL);
	glEnable(GL_LIGHTING);
	glLightfv(GL_LIGHT0, GL_AMBIENT, LightAmbient); 
	glLightfv(GL_LIGHT1, GL_DIFFUSE, LightDiffuse);    //   
	glLightfv(GL_LIGHT1, GL_POSITION, LightPosition);   //  
	glEnable(GL_LIGHT1);
	glEnable(GL_LIGHT0);
}
void light::move_to_pos()
{
	glLightfv(GL_LIGHT1, GL_POSITION, LightPosition);  
	
}