#include <windows.h>   //    Windows
#include <gl\gl.h>                        //    OpenGL32 
#include <gl\glu.h>                       //    GLu32 
#include <gl\glaux.h>                     //    GLaux 
#include <iostream> 
#include <string>
#include <sstream>
enum menunum_ main_,ingame_,save_,load_,shop_;
//#include "HKtools_pack.h"
#include <shlwapi.h>
#include <math.h>
#include "game.h"
#include "text.h"
#include "framerate.h"
#include "menu.h"
static HGLRC hRC;       //   
static HDC hDC;         //    GDI
BOOL    keys[256];      //     
int cam;
int last_level=1;
HWND            hWnd;   //   
light *Light;
models *model;
models *cont;
textures *Textures_big;
textures *Textures_small;
textures *Textures_other;
textures *textures_cont;
textures *sky;
TGA_texture *tga;
game *GAME;
Font *text;
char txt[255];
char zon_name[255];
frame_normalizer *frame;
flat_menu* menu;
flat_menu* gamemenu;
flat_menu* savemenu;
flat_menu* loadmenu;
flat_menu* shopmenu;
flat_menu* optionsmenu;
int mousex,mousey;
BOOL mouse[3];
POINT mouse_pos;
void gen_cont_list()
{
	int a,b;
	glNewList(100,GL_COMPILE);
	glBindTexture(GL_TEXTURE_2D,sky->texture[0]);//
	glTranslatef(0,-GAME->height/2-2,0);
	glCallList(model->model[6]);
	glTranslatef(0,GAME->height/2+2,0);

	glBindTexture(GL_TEXTURE_2D,Textures_other->texture[2]);//
	glBegin(GL_QUADS);
		glTexCoord2d(0,50);
		glVertex3f(-100,-GAME->height/2-0.1,-100);
		glTexCoord2d(100,50);
		glVertex3f(100,-GAME->height/2-0.1,-100);
		glTexCoord2d(100,0);
		glVertex3f(100,-GAME->height/2-0.1,-1);
		glTexCoord2d(0,0);
		glVertex3f(-100,-GAME->height/2-0.1,-1);

		glTexCoord2d(0,50);
		glVertex3f(-100,-GAME->height/2-0.1,100);
		glTexCoord2d(100,50);
		glVertex3f(100,-GAME->height/2-0.1,100);
		glTexCoord2d(100,0);
		glVertex3f(100,-GAME->height/2-0.1,1);
		glTexCoord2d(0,0);
		glVertex3f(-100,-GAME->height/2-0.1,1);

		glTexCoord2d(0,1);
		glVertex3f(-100,-GAME->height/2-0.1,-1);
		glTexCoord2d(100,1);
		glVertex3f(100,-GAME->height/2-0.1,-1);
		glTexCoord2d(100,0);
		glVertex3f(100,-GAME->height/2-0.1,1);
		glTexCoord2d(0,0);
		glVertex3f(-100,-GAME->height/2-0.1,1);

	glEnd();


	glTranslatef(-100,-GAME->height/2,1);
	//
	for(a=0;a<200;a++)
	{
		glBindTexture(GL_TEXTURE_2D,Textures_other->texture[2+GAME->road[a]]);
		glCallList(model->model[6+GAME->road[a]]);
		glTranslatef(1,0,0);
	}
	glTranslatef(-200,0,-2);
	for(a=0;a<200;a++)
	{
		glBindTexture(GL_TEXTURE_2D,Textures_other->texture[2+GAME->road[200-a]]);
		glCallList(model->model[6+GAME->road[200-a]]);
		glTranslatef(1,0,0);
	}
	glTranslatef(-150,0,-49);
	for(a=0;a<100;a++)
	{
		for(b=0;b<100;b++)
		{
			if(GAME->cont[a][b][0]!=0)
			{
				glTranslated(b,0,a);
				glRotatef(GAME->cont[a][b][1],0,1,0);
				glBindTexture(GL_TEXTURE_2D,textures_cont->texture[GAME->cont[a][b][0]-1]);
				glCallList(cont->model[GAME->cont[a][b][0]-1]);
				glRotatef(-GAME->cont[a][b][1],0,1,0);
				glTranslated(-b,0,-a);
			}
		}
	}
	glTranslatef(50.0f,GAME->height/2,50.0f);
	glEndList();
}
void kill_cont_list()
{
	glDeleteLists(100,1);
}

//--------------------------------
void load_zone(char *zone_name)
{
	sprintf(zon_name,"%s",zone_name);
	char buf[50];
	int a,count;
	FILE *fil;

	cont->First=12;
	sprintf(buf,"models//%s//cont_conf",zone_name);
	fil=fopen(buf,"rb");
	fscanf(fil,"%d",&count);
	fclose(fil);
	for(a=1;a<=count;a++)
	{
		sprintf(buf,"models//%s//cont%d.md0b",zone_name,a);
		cont->load_model_binary(buf);
		sprintf(buf,"maps//%s//cont//cont%d.jpg",zone_name,a);
		textures_cont->buildtexture(buf);
	}
	sprintf(buf,"models//%s//bomber.md0b",zone_name);
	model->load_model_binary(buf);
	sprintf(buf,"models//%s//bomb.md0b",zone_name);
	model->load_model_binary(buf);
	sprintf(buf,"models//%s//main.md0b",zone_name);
	model->load_model_binary(buf);
	sprintf(buf,"models//%s//up.md0b",zone_name);
	model->load_model_binary(buf);
	sprintf(buf,"models//%s//dest_up.md0b",zone_name);
	model->load_model_binary(buf);
	sprintf(buf,"models//%s//small1.md0b",zone_name);
	model->load_model_binary(buf);
	sprintf(buf,"models//%s//sky.md0b",zone_name);
	model->load_model_binary(buf);
	sprintf(buf,"models//%s//road1.md0b",zone_name);
	model->load_model_binary(buf);
	sprintf(buf,"models//%s//road2.md0b",zone_name);
	model->load_model_binary(buf);
	sprintf(buf,"models//%s//road3.md0b",zone_name);
	model->load_model_binary(buf);
//-----------------------------------------------------
	sprintf(buf,"maps//%s//bomb.bmp",zone_name);
	Textures_other->buildtexture(buf);
		sprintf(buf,"maps//%s//sky//sky_.jpg",zone_name);
		sky->buildtexture(buf);

	sprintf(buf,"maps//%s//ground.jpg",zone_name);
	Textures_other->buildtexture(buf);

	sprintf(buf,"maps//%s//road//road1.jpg",zone_name);
	Textures_other->buildtexture(buf);
	sprintf(buf,"maps//%s//road//road2.jpg",zone_name);
	Textures_other->buildtexture(buf);
	sprintf(buf,"maps//%s//road//road3.jpg",zone_name);
	Textures_other->buildtexture(buf);

	sprintf(buf,"maps//%s//building1.jpg",zone_name);
	Textures_big->buildtexture(buf);
	sprintf(buf,"maps//%s//small1.jpg",zone_name);
	Textures_small->buildtexture(buf);
	sprintf(buf,"maps//%s//bomber.tga",zone_name);
	tga->LoadTGA(buf);
}
void unload_zone()
{
	int a,count;
	FILE *fil;
	char buf[255];
	sprintf(buf,"models//%s//cont_conf",zon_name);
	sprintf(zon_name,"");
	fil=fopen(buf,"rb");
	fscanf(fil,"%d",&count);
	cont->unload();
	tga->unload();
	model->unload();
	Textures_other->unload();
	Textures_big->unload();
	Textures_small->unload();
	textures_cont->unload();
	Textures_other->buildtexture("maps\\loading.JPG");
}
void draw_loading()
{
	int a;
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();
	Light->move_to_pos();

	glBindTexture(GL_TEXTURE_2D,Textures_other->texture[0]);
	
	glTranslatef(0,0,-15.0f);
	glBegin(GL_POLYGON);
	glTexCoord2d(0,1);
	glVertex3f(-10,10,0);
	glTexCoord2d(1,1);
	glVertex3f(10,10,0);
	glTexCoord2d(1,0);
	glVertex3f(10,-10,0);
	glTexCoord2d(0,0);
	glVertex3f(-10,-10,0);

	glEnd();
	SwapBuffers(hDC);   
}

GLvoid InitGL(GLsizei Width, GLsizei Height)    //     GL
{
	//------------------------
	// light
	Light->light_init();						//     
	//-------------------------
	glEnable(GL_TEXTURE_2D);      //   
	glClearColor(1.0f, 1.0f, 1.0f, 0.0f);   
	glEnable(GL_POLYGON_SMOOTH);
	glClearDepth(1.0);                      //    
    glHint(GL_LINE_SMOOTH_HINT, GL_NICEST); //  
    //glEnable(GL_BLEND);         //  

    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA); //  
	glEnable(GL_ALPHA_TEST);
	glDepthFunc(GL_LEQUAL);
    glEnable(GL_DEPTH_TEST);                //   
	glShadeModel(GL_SMOOTH);        //    
    glMatrixMode(GL_PROJECTION);    //   
	
    glLoadIdentity();               //   
    gluPerspective(45.0f,(GLfloat)Width/(GLfloat)Height,0.1f,1600.0f);
                                //      
    glMatrixMode(GL_MODELVIEW);     //    
	glEnable(GL_LIGHT1);
	glEnable(GL_LIGHT0);
	



/*	typedef BOOL (APIENTRY * wglSwapIntervalEXT_Func)(int);
wglSwapIntervalEXT_Func wglSwapIntervalEXT =  wglSwapIntervalEXT_Func(wglGetProcAddress("wglSwapIntervalEXT"));
wglSwapIntervalEXT(0);*/

}
GLvoid ReSizeGLScene(GLsizei Width, GLsizei Height)
{
        if (Height==0)          //    ,    
                Height=1;

        glViewport(0, 0, Width, Height);
                //       

        glMatrixMode(GL_PROJECTION);            //   
        glLoadIdentity();                       //   

		gluPerspective(45.0f,(GLfloat)Width/(GLfloat)Height,0.1f,1600.0f);
        glMatrixMode(GL_MODELVIEW);     //    
}

GLvoid DrawGLScene(GLvoid)
{		
	int a,b;
	
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();
	glDisable(GL_BLEND); 
    if (cam==0)gluLookAt(GAME->player->x,GAME->height-GAME->player->y+1,0,GAME->player->x,-10,0,1,0,0);
	if(cam==1)gluLookAt(GAME->width/4+GAME->player->x/2,-GAME->height/2+3,(GAME->height*1.7-GAME->player->y),GAME->player->x,(GAME->height/2-GAME->player->y)/2,0,0,1,0);
    if(cam==2)gluLookAt(GAME->width/4+GAME->player->x/2,sqrtl((GAME->height-GAME->player->y)*(GAME->height-GAME->player->y)*(GAME->height-1))/4,(GAME->height*1.7-GAME->player->y),GAME->player->x,(GAME->height/2-GAME->player->y)/2,0,0,1,0);
	Light->move_to_pos();

	//------------------------------
	// map
	for(a=0;a<=GAME->width;a++)
	{
		if(GAME->count_types_small>0)
		{
			if(GAME->map[a][GAME->height-1]>0)	glBindTexture(GL_TEXTURE_2D,Textures_big->texture[(int)(GAME->map[a][GAME->height]/3)]);
			else
			{
				if((GAME->map[a][GAME->height]>GAME->count_types_big*3))
				{
					glBindTexture(GL_TEXTURE_2D,Textures_small->texture[(int)(GAME->map[a][GAME->height])-GAME->count_types_small*3-1]);
				}
				else if(GAME->map[a][GAME->height]!=0)
				{
					glBindTexture(GL_TEXTURE_2D,Textures_big->texture[(int)(GAME->map[a][GAME->height]/3)-1]);
				}
			}

		}
		else glBindTexture(GL_TEXTURE_2D,Textures_big->texture[(int)(GAME->map[a][GAME->height]/3)]);

		for(b=0;b<=GAME->height;b++)
		{
			
			if(GAME->map[a][b]>0) 
			{
		
				glTranslatef((GLfloat)a,(GAME->height/2)-(GLfloat)b,-0.5);
				glCallList(GAME->map[a][b]+2);
				glTranslatef(-((GLfloat)a),-((GAME->height/2)-(GLfloat)b),0.5);
			}
		}

	}
	//------------------------------
	// player
	glTranslatef(GAME->player->x,((GAME->height/2)-GAME->player->y),0);
	glBindTexture(GL_TEXTURE_2D,tga->texID);
	//glCallList(model->model[0]);
	GAME->player->draw();
	glTranslatef(-(GAME->player->x),-((GAME->height/2)-GAME->player->y),0);
	//------------------------------
	//bombs
	for(a=0;a<10;a++)
	{
		if(GAME->bombs[a]->visible==true)
		{
			glTranslatef(GAME->bombs[a]->x,((GAME->height/2)-GAME->bombs[a]->y),0);
			glBindTexture(GL_TEXTURE_2D,Textures_other->texture[1]);
			glCallList(model->model[1]);
			glTranslatef(-(GAME->bombs[a]->x),-((GAME->height/2)-GAME->bombs[a]->y),0);
		}
	}




	//
	glTranslatef(0,-1,0);
	glCallList(100);
	glTranslatef(0,1,0);
	for(a=0;a<10;a++)
	{
				GAME->explosions[a]->draw();

	}

	//glLoadIdentity();
	//glTranslatef(-100,0,1);
	
				
	//
	
}
LRESULT CALLBACK WndProc(HWND    hWnd,UINT    message,WPARAM  wParam,LPARAM  lParam)
{
        RECT    Screen;         //     
        GLuint  PixelFormat;
        static  PIXELFORMATDESCRIPTOR pfd=
        {
                sizeof(PIXELFORMATDESCRIPTOR),  //   
        1.2,                              //   (?)
        PFD_DRAW_TO_WINDOW |            //   
        PFD_SUPPORT_OPENGL |            //   OpenGL
        PFD_DOUBLEBUFFER ,               //    
        PFD_TYPE_RGBA,                  //  RGBA 
        32,                             //  32   
        0, 0, 0, 0, 0, 0,                       //    (?)
        1,                              //   
        0,                              //    (?)
        1,                              //   
        0, 0, 0, 0,                             //    (?)
        128,                             // 32  Z- ( ) 
        0,                              //   
        0,                              //    (?)
        PFD_MAIN_PLANE,                 //   
        0,                              //  (?)
        0, 0, 0                         //    (?)
        };

		 switch (message)        //  
        {
			        case WM_CREATE:
                hDC = GetDC(hWnd);      //     
                PixelFormat = ChoosePixelFormat(hDC, &pfd);



                        //       
				        if (!PixelFormat)
                {
                        MessageBox(0,"Can't Find A Suitable PixelFormat.","Error",MB_OK|MB_ICONERROR);
                        PostQuitMessage(0);
                        //   ,    
                break;  //   
                }
						      if(!SetPixelFormat(hDC,PixelFormat,&pfd))
                {
                        MessageBox(0,"Can't Set The PixelFormat.","Error",MB_OK|MB_ICONERROR);
                        PostQuitMessage(0);
                        break;
                }
		hRC = wglCreateContext(hDC);
        if(!hRC)
                {
                MessageBox(0,"Can't Create A GL Rendering Context.","Error",MB_OK|MB_ICONERROR);
                PostQuitMessage(0);
                break;
                }
		        if(!wglMakeCurrent(hDC, hRC))
                {
                MessageBox(0,"Can't activate GLRC.","Error",MB_OK|MB_ICONERROR);
                PostQuitMessage(0);
                break;
                }
				       GetClientRect(hWnd, &Screen);
                InitGL(Screen.right, Screen.bottom);
                break;
				        case WM_DESTROY:
                case WM_CLOSE:
                ChangeDisplaySettings(NULL, 0);

                wglMakeCurrent(hDC,NULL);
                wglDeleteContext(hRC);
                ReleaseDC(hWnd,hDC);

                PostQuitMessage(0);
                break;
				   case WM_KEYDOWN:
                keys[wParam] = TRUE;
                break;
				        case WM_KEYUP:
                keys[wParam] = FALSE;
                break;
				case WM_LBUTTONDOWN:
					mouse[1] = TRUE;
					break;
				case WM_LBUTTONUP:
					mouse[1] = FALSE;
					break;
				case WM_RBUTTONDOWN:
					mouse[2] = TRUE;
					break;
				case WM_RBUTTONUP:
					mouse[2] = FALSE;
					break;
				 case WM_SIZE:
                ReSizeGLScene(LOWORD(lParam),HIWORD(lParam));
                break;
				    default:
        return (DefWindowProc(hWnd, message, wParam, lParam));
        }

        return (0);
}
int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow)
{
	int a,b,scr;
	Textures_other=new textures();
	bool ingame=false;
	bool loaded=false;
	bool fullscreen=false,soundenabled=false;
	FILE * fil2;
	int menunum=0;
	char buf[20];
	char buf2[1000];
	tga=new TGA_texture();
	Light=new light();
	model = new models(12);
	Light->set_diffuse(0.1,0.1,0.1,1);
	Light->set_ambient(4,4,4,4);
	Light->set_pos(-200,0,10,-10);
	mouse[1]=false;
	int screen_width,screen_height;
	if(fil2=fopen("grf.cfg","rb"))
	{
		fscanf(fil2,"%s",buf2);
		fscanf(fil2,"%s",buf2);
		fscanf(fil2,"%s",buf2);
		a=atoi(buf2);
		if(a==1)
		{
			screen_width=320;
			screen_height=240;
		}
		if(a==2)
		{
			screen_width=640;
			screen_height=480;
		}
		if(a==3)
		{
			screen_width=800;
			screen_height=600;
		}
		if(a==4)
		{
			screen_width=1024;
			screen_height=768;
		}
		if(a==5)
		{
			screen_width=1280;
			screen_height=1024;
		}
		scr=a;
		fscanf(fil2,"%s",buf2);
		a=atoi(buf2);
		if(a==1)fullscreen=true;
		else fullscreen=false;
		fscanf(fil2,"%s",buf2);
		a=atoi(buf2);
		if(a==1)soundenabled=true;
		else soundenabled=false;

	}
	else
	{
		scr=1;
		fil2=fopen("grf.cfg","wb");
		fprintf(fil2,"30.0 1.0 1 0 0");
		screen_width=320;
		screen_height=240;
	}
	fclose(fil2);
        MSG             msg;    //   Windows
        WNDCLASS        wc; //   Windows    
      
		    wc.style                = CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
        wc.lpfnWndProc          = (WNDPROC) WndProc;
        wc.cbClsExtra           = 0;
        wc.cbWndExtra           = 0;
        wc.hInstance            = hInstance;
        wc.hIcon                = NULL;
        wc.hCursor              = LoadCursor(NULL, IDC_ARROW);
        wc.hbrBackground        = NULL;
        wc.lpszMenuName         = NULL;
        wc.lpszClassName        = "window";
		  if(!RegisterClass(&wc))
        {
        MessageBox(0,"Failed To Register The Window Class.","Error",MB_OK|MB_ICONERROR);
        return FALSE;
        }
		      hWnd = CreateWindow("window","BoMbEr", //   

        WS_POPUP |
        WS_CLIPCHILDREN |
        WS_CLIPSIBLINGS,

        0, 0,                   //    
       screen_width, screen_height,               //    

        NULL,
        NULL,
        hInstance,
        NULL);
			   if(!hWnd)
        {
        MessageBox(0,"Window Creation Error.","Error",MB_OK|MB_ICONERROR); 
                return FALSE;
        }
			   DEVMODE dmScreenSettings;                       //  

memset(&dmScreenSettings, 0, sizeof(DEVMODE));          //    
dmScreenSettings.dmSize = sizeof(DEVMODE);              //   Devmode
dmScreenSettings.dmPelsWidth    = screen_width;                  //  
dmScreenSettings.dmPelsHeight   = screen_height;                  //  
dmScreenSettings.dmFields       = DM_PELSWIDTH | DM_PELSHEIGHT; //  
dmScreenSettings.dmDisplayFrequency= 75;
if(fullscreen==true)ChangeDisplaySettings(&dmScreenSettings, CDS_FULLSCREEN);

        //    
ShowWindow(hWnd, SW_SHOW);
        UpdateWindow(hWnd);
        SetFocus(hWnd);
if (soundenabled==true)alutInit(NULL,NULL);
auxInitDisplayMode( AUX_RGB | AUX_DEPTH | AUX_DOUBLE );

Textures_other->buildtexture("maps\\loading.JPG");
Light->set_diffuse(1,1,1,1);
Light->set_ambient(1,1,1,2);
Light->set_pos(0,0,100,100);
draw_loading();
GAME=new game(1);
model = new models(1);
Textures_big=new textures();
Textures_small=new textures();	
textures_cont=new textures();
cont=new models(1);
sky=new textures();


menu=new flat_menu();
gamemenu=new flat_menu();
savemenu=new flat_menu();
loadmenu=new flat_menu();
shopmenu=new flat_menu();
optionsmenu=new flat_menu();

menu->screen_height=screen_height;
gamemenu->screen_height=screen_height;
savemenu->screen_height=screen_height;
loadmenu->screen_height=screen_height;
shopmenu->screen_height=screen_height;
optionsmenu->screen_height=screen_height;

menu->load_from_file("menus\\menu.txt",hDC);
gamemenu->load_from_file("menus\\game.txt",hDC);
savemenu->load_from_file("menus\\save.txt",hDC);
loadmenu->load_from_file("menus\\load.txt",hDC);
shopmenu->load_from_file("menus\\shop.txt",hDC);
optionsmenu->load_from_file("menus\\options.txt",hDC);

menu->set_screen_height(screen_height);
gamemenu->set_screen_height(screen_height);
savemenu->set_screen_height(screen_height);
loadmenu->set_screen_height(screen_height);
shopmenu->set_screen_height(screen_height);
optionsmenu->set_screen_height(screen_height);

frame=new frame_normalizer;
text=new Font;
frame->set_normal_framerate(60);
cam=1;
ingame=false;
FILE *fil;
	 while (1)
        {
			                //   
             while (PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE))
                {
                        if (GetMessage(&msg, NULL, 0, 0))
                        {
                                TranslateMessage(&msg);
                                DispatchMessage(&msg);
                        }
                        else
                        {
                                return TRUE;
                        }
                }
			if (ingame==true)
			{
				b=frame->check();
				if (b==0)
				{

					DrawGLScene(); 
					SwapBuffers(hDC);
				}
				else if (b==1)
				{
					DrawGLScene();  
					SwapBuffers(hDC); 
					for(a=0;a<10;a++)
					{
						GAME->explosions[a]->move();
					}	
					GAME->move_player();
					GAME->bombing();
					if(GAME->win()==true)
					{
						if (last_level<GAME->player->level)
						{
							draw_loading();
							kill_cont_list();
							unload_zone();
							GAME->unload();
							GAME->load(GAME->player->level);
							sprintf(buf2,"zone%d",GAME->player->level);
							load_zone(buf2);
							last_level=GAME->player->level;

						}
						ingame=false;
					}
					if(keys[VK_SPACE])
					{
						GAME->drop_bomb();
						keys[VK_SPACE]=false;
					}					
					if (keys[VK_ESCAPE])
					{
						keys[VK_ESCAPE]=false;
						ingame=false;
					}
					if(GAME->gameover()==true)
					{
						ingame=false;
						menunum=1;
					gamemenu->unclick();
					}
					if(keys[67])
					{
						keys[67]=false;
						cam++;
						if(cam>2)cam=0;
					}
					if(keys[VK_LEFT])//
				{
					keys[VK_LEFT]=false;
					if(GAME->player->slow>0)
					{
						if(GAME->player->up_active==false&&GAME->player->slow_active==false&&GAME->player->stop_active==false)
						{
							GAME->player->slow--;
							GAME->player->slow_active=true;
						}
					}
				}
				if(keys[VK_UP])//
				{
					keys[VK_UP]=false;
					if(GAME->player->up>0)
					{
						if(GAME->player->up_active==false&&GAME->player->slow_active==false&&GAME->player->stop_active==false)
						{
							GAME->player->up--;
							GAME->player->up_active=true;
						}
					}
				}
				if(keys[VK_DOWN])//
				{
					keys[VK_DOWN]=false;
					if(GAME->player->stop>0)
					{
						if(GAME->player->up_active==false&&GAME->player->slow_active==false&&GAME->player->stop_active==false)
						{
							GAME->player->stop--;
							GAME->player->stop_active=true;
						}
					}
				}
				if(keys[VK_RIGHT])//
				{
					keys[VK_RIGHT]=false;
					GAME->player->points+=100;
				}
				if(GAME->gameover()==true)
					{
						ingame=false;
						//break;
					}

				}
				else if (b==-1)
				{
					GAME->move_player();
					GAME->bombing();
					for(a=0;a<10;a++)
					{
						GAME->explosions[a]->move();
					}
					if(GAME->win()==true)
					{
						if (last_level<GAME->player->level)
						{
							draw_loading();
							kill_cont_list();
							unload_zone();
							GAME->unload();
							GAME->load(GAME->player->level);
							sprintf(buf2,"zone%d",GAME->player->level);
							load_zone(buf2);
							last_level=GAME->player->level;

						}
						ingame=false;
					}
				if(keys[VK_SPACE])// 
					{
						GAME->drop_bomb();
						keys[VK_SPACE]=false;
					}
				if (keys[VK_ESCAPE])//
					{
						keys[VK_ESCAPE]=false;
						ingame=false;
					}
				if(keys[67])//
					{
						keys[67]=false;
						cam++;
						if(cam>2)cam=0;
					}
				if(keys[VK_LEFT])//
				{
					keys[VK_LEFT]=false;
					if(GAME->player->slow>0)
					{
						if(GAME->player->up_active==false&&GAME->player->slow_active==false&&GAME->player->stop_active==false)
						{
							GAME->player->slow--;
							GAME->player->slow_active=true;
						}
					}
				}
				if(keys[VK_UP])//
				{
					keys[VK_UP]=false;
					if(GAME->player->up>0)
					{
						if(GAME->player->up_active==false&&GAME->player->slow_active==false&&GAME->player->stop_active==false)
						{
							GAME->player->up--;
							GAME->player->up_active=true;
						}
					}
				}
				if(keys[VK_DOWN])//
				{
					keys[VK_DOWN]=false;
					if(GAME->player->stop>0)
					{
						if(GAME->player->up_active==false&&GAME->player->slow_active==false&&GAME->player->stop_active==false)
						{
							GAME->player->stop--;
							GAME->player->stop_active=true;
						}
					}
				}
				if(keys[VK_RIGHT])//
				{
					keys[VK_RIGHT]=false;
					GAME->player->points+=100;
				}
				if(GAME->gameover()==true)
					{
						ingame=false;
						//break;
					}
				}
			}
			if (ingame==false)
			{
				GAME->load_conf("grf.cfg");
				glEnable(GL_TEXTURE_2D);
				glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
                //     
				glLoadIdentity();
				glColor3f(1.0f,1.0f,1.0f);
				Light->move_to_pos();
				if(menunum==0)menu->draw();
				else if(menunum==1)gamemenu->draw();
				else if(menunum==2)savemenu->draw();
				else if(menunum==3)loadmenu->draw();
				else if(menunum==5)
				{

					
					if(fullscreen==false)sprintf(buf2,"  .");
					else sprintf(buf2,"  .");
					optionsmenu->buttons[2]->set_text(buf2);
					if(soundenabled==false)sprintf(buf2," .");
					else sprintf(buf2," .");
					optionsmenu->buttons[3]->set_text(buf2);
					a=optionsmenu->sliders[1]->get_value(true);
					if(a==1)sprintf(buf2,"320X240");
					if(a==2)sprintf(buf2,"640X480");
					if(a==3)sprintf(buf2,"800X600");
					if(a==4)sprintf(buf2,"1024X768");
					if(a==5)sprintf(buf2,"1280X984");
					optionsmenu->messages[2]->set_text(buf2);
					optionsmenu->draw();
				}
				else if(menunum==4)
				{
					sprintf(buf2,": %d",GAME->player->points);
					shopmenu->messages[1]->set_text(buf2);
					sprintf(buf2," : %d",GAME->player->count_bombs);
					shopmenu->messages[2]->set_text(buf2);
					sprintf(buf2," : %d",GAME->player->bomb_destruction);
					shopmenu->messages[3]->set_text(buf2);
					sprintf(buf2," : %d",GAME->player->bomb_speeder);
					shopmenu->messages[4]->set_text(buf2);
					sprintf(buf2," : %d",GAME->player->up);
					shopmenu->messages[5]->set_text(buf2);
					sprintf(buf2,": %d",GAME->player->stop);
					shopmenu->messages[6]->set_text(buf2);
					sprintf(buf2,": %d",GAME->player->slow);
					shopmenu->messages[7]->set_text(buf2);
					sprintf(buf2,". %.0lf",(pow(2,GAME->player->count_bombs)*100));
					shopmenu->buttons[0]->set_text(buf2);
					sprintf(buf2,". %.0lf",(pow(5,GAME->player->bomb_destruction)*100));
					shopmenu->buttons[1]->set_text(buf2);
					sprintf(buf2,". %.0lf",(pow(4,(GAME->player->bomb_speeder+1))*10));
					shopmenu->buttons[2]->set_text(buf2);
					shopmenu->draw();

					
				}
				SwapBuffers(hDC);  
				GetCursorPos(&mouse_pos);
				mousex=mouse_pos.x;
				mousey=mouse_pos.y;
				 if(mouse[1]==true)
				 {
					 if(menunum==0) 
					 {
						 menu->click(mouse_pos.x,mouse_pos.y);
						 gamemenu->unclick();
						 savemenu->unclick();
						 loadmenu->unclick();
						 shopmenu->unclick();
						 optionsmenu->unclick();
					 }
					 if(menunum==1) 
					 {
						 gamemenu->click(mouse_pos.x,mouse_pos.y);
						 menu->unclick();
						 savemenu->unclick();
						 loadmenu->unclick();
						 shopmenu->unclick();
						 optionsmenu->unclick();

					 }
					 if(menunum==2) 
					 {
						 savemenu->click(mouse_pos.x,mouse_pos.y);
						 menu->unclick();
						 gamemenu->unclick();
						 loadmenu->unclick();
						 shopmenu->unclick();
						 optionsmenu->unclick();
					 }
					 if(menunum==3) 
					 {
						 loadmenu->click(mouse_pos.x,mouse_pos.y);
						 menu->unclick();
						 gamemenu->unclick();
						 savemenu->unclick();
						 shopmenu->unclick();
						 optionsmenu->unclick();
					 }
					 if(menunum==4) 
					 {
						 shopmenu->click(mouse_pos.x,mouse_pos.y);
						 menu->unclick();
						 gamemenu->unclick();
						 loadmenu->unclick();
						 savemenu->unclick();
						 optionsmenu->unclick();
					 }
					 if(menunum==5) 
					 {
						 optionsmenu->click(mouse_pos.x,mouse_pos.y);
						 menu->unclick();
						 gamemenu->unclick();
						 loadmenu->unclick();
						 savemenu->unclick();
						 shopmenu->unclick();
					 }
					if(menunum!=5) mouse[1]=false;
				 }
				 else if(mouse[1]==false)
				 {

					 if(menunum==0) menu->unclick();	
					 if(menunum==1) gamemenu->unclick();
				 }
				 if(menunum==0)
				 {
					if(menu->button_clicked[0]==true) 
					{

						draw_loading();
						sprintf(zon_name,"zone1");
						unload_zone();
						GAME->unload();
						GAME->load(1);
						load_zone("zone1");	
						GAME->player->clear();
						menunum=1;
					}
					if(menu->button_clicked[1]==true) 
					{
						sprintf(zon_name,"zone1");
						menunum=3;
					}
					if(menu->button_clicked[2]==true) 
					{
						SendMessage(hWnd,WM_CLOSE,0,0); 
					}
					if(menu->button_clicked[3]==true) 
					{
						GAME->load_conf("grf.cfg");
						menunum=5;
						optionsmenu->sliders[0]->Pos=-GAME->building_density;
						optionsmenu->sliders[1]->Pos=-scr;
						
					}
				 }
				 else if(menunum==1)
				 {
					if(gamemenu->button_clicked[0]==true) 
					{
						draw_loading();	
						GAME->clear();
						kill_cont_list();
						GAME->height=(GAME->player->level-1)*10+GAME->player->phase+3;
						GAME->width=GAME->player->level*10+GAME->player->phase+3;
						GAME->generate(GAME->player->level*5+GAME->player->phase+3,GAME->player->level*5+GAME->player->phase+3,GAME->player->level*5+GAME->player->phase+1);
						GAME->player->fly_speed=0.05;
						GAME->player->bomb_speed=0.05;
						gen_cont_list();
						ingame=true;
					}
					if(gamemenu->button_clicked[1]==true) 
					{
						 if(GAME!=NULL)ingame=true;
					}
					if(gamemenu->button_clicked[2]==true) 
					{
						menunum=4;
					}
					if(gamemenu->button_clicked[3]==true) 
					{
						menunum=2;
					}
					if(gamemenu->button_clicked[4]==true) 
					{
						 menunum=0;
					}
				 }
				 else if(menunum==2)
				 {
					if(savemenu->message_clicked[0]==true)
					{
						savemenu->message_clicked[0]=false;
						savemenu->messages[0]->visible=false;
					}
					if(savemenu->button_clicked[0]==true) 
					{
						 GAME->player->save("save1.sav");
						 savemenu->messages[0]->visible=true;
						 savemenu->button_clicked[0]=false;
					}
					if(savemenu->button_clicked[1]==true) 
					{
						 GAME->player->save("save2.sav");
						 savemenu->messages[0]->visible=true;
						 savemenu->button_clicked[1]=false;
					}
					if(savemenu->button_clicked[2]==true) 
					{
						 GAME->player->save("save3.sav");
						 savemenu->messages[0]->visible=true;
						 savemenu->button_clicked[2]=false;
					}
					if(savemenu->button_clicked[3]==true) 
					{
						 GAME->player->save("save4.sav");
						 savemenu->messages[0]->visible=true;
						 savemenu->button_clicked[3]=false;
					}
					else if(savemenu->button_clicked[4]==true) 
					{
						 menunum=1;
					}
				 }
				 else if(menunum==3)
				 {
					if(loadmenu->message_clicked[0]==true&&loaded==true)
					{
						loadmenu->message_clicked[0]=false;
						menunum=1;
						loaded=false;
						loadmenu->messages[0]->visible=false;
					}
					else if(loadmenu->message_clicked[0]==true&&loaded==false)
					{
						loadmenu->message_clicked[0]=false;
						loadmenu->messages[0]->visible=false;
					}
					if(loadmenu->messages[0]->visible==false)
					{
					if(loadmenu->button_clicked[0]==true) 
					{
						 if(GAME->player->load("save1.sav"))
						 {
							loadmenu->messages[0]->set_text("**");
							loadmenu->messages[0]->visible=true;
							loadmenu->button_clicked[0]=false;
							loaded=true;
							kill_cont_list();
							unload_zone();
							GAME->unload();
							GAME->load(GAME->player->level);
							sprintf(buf2,"zone%d",GAME->player->level);
							load_zone(buf2);
							last_level=GAME->player->level;

						}
						else
						{
							loadmenu->messages[0]->set_text("***");
							loadmenu->messages[0]->visible=true;
							loadmenu->button_clicked[0]=false;
							loaded=false;
						}
					}
					else if(loadmenu->button_clicked[1]==true) 
					{
						 if(GAME->player->load("save2.sav"))
						 {
							loadmenu->messages[0]->set_text("**");
							loadmenu->messages[0]->visible=true;
							loadmenu->button_clicked[1]=false;
							loaded=true;
							kill_cont_list();
							unload_zone();
							GAME->unload();
							GAME->load(GAME->player->level);
							sprintf(buf2,"zone%d",GAME->player->level);
							load_zone(buf2);
							last_level=GAME->player->level;
						}
						else
						{
							loadmenu->messages[0]->set_text("***");
							loadmenu->messages[0]->visible=true;
							loadmenu->button_clicked[1]=false;
							loaded=false;
						}
					}
					else if(loadmenu->button_clicked[2]==true) 
					{
						 if(GAME->player->load("save3.sav"))
						 {
							loadmenu->messages[0]->set_text("**");
							loadmenu->messages[0]->visible=true;
							loadmenu->button_clicked[2]=false;
							loaded=true;
							kill_cont_list();
							unload_zone();
							GAME->unload();
							GAME->load(GAME->player->level);
							sprintf(buf2,"zone%d",GAME->player->level);
							load_zone(buf2);
							last_level=GAME->player->level;
						}
						else
						{
							loadmenu->messages[0]->set_text("***");
							loadmenu->messages[0]->visible=true;
							loadmenu->button_clicked[2]=false;
							loaded=false;
						}
					}
					else if(loadmenu->button_clicked[3]==true) 
					{
						if(GAME->player->load("save4.sav"))
						 {
							loadmenu->messages[0]->set_text("**");
							loadmenu->messages[0]->visible=true;
							loadmenu->button_clicked[3]=false;
							loaded=true;
							kill_cont_list();
							unload_zone();
							GAME->unload();
							GAME->load(GAME->player->level);
							sprintf(buf2,"zone%d",GAME->player->level);
							load_zone(buf2);
							last_level=GAME->player->level;
						}
						else
						{
							loadmenu->messages[0]->set_text("***");
							loadmenu->messages[0]->visible=true;
							loadmenu->button_clicked[3]=false;
							loaded=false;
						}
					}
					else if(loadmenu->button_clicked[4]==true) 
					{
						 menunum=0;
					}
					}
				 }
				 else if(menunum==4)
				 {
					 if(shopmenu->message_clicked[8]==true)
					 {	
						shopmenu->message_clicked[8]=false;
						shopmenu->messages[8]->visible=false;
					 }
					 else
					 {
						if(shopmenu->button_clicked[6]==true)
						{
							menunum=1;
						}
						if(shopmenu->button_clicked[0]==true)
						{
							 if(GAME->player->points>=pow(2,GAME->player->count_bombs)*100)
							 {
								 if(GAME->player->count_bombs<10)
								 {
									 GAME->player->points-=pow(2,GAME->player->count_bombs)*100;
									 GAME->player->count_bombs++;
									 sprintf(buf2," * !");
									 shopmenu->messages[8]->set_text(buf2);
								     shopmenu->messages[8]->visible=true;
								     shopmenu->button_clicked[0]=false;
								 }
								 else
								 {
									sprintf(buf2,"* * . * * * .");
									shopmenu->messages[8]->set_text(buf2);
								    shopmenu->messages[8]->visible=true;
								    shopmenu->button_clicked[0]=false;
								 }
							 }
							 else
							 {
							    sprintf(buf2,"* * .**** ");
							    shopmenu->messages[8]->set_text(buf2);
								shopmenu->messages[8]->visible=true;
								shopmenu->button_clicked[0]=false;
							 }
						}
						else if(shopmenu->button_clicked[1]==true)
						{
							 if(GAME->player->points>=pow(5,GAME->player->bomb_destruction)*100)
							 {

									 GAME->player->points-=pow(5,GAME->player->bomb_destruction)*100;
									 GAME->player->bomb_destruction++;
									 sprintf(buf2," ** !");
									 shopmenu->messages[8]->set_text(buf2);
								     shopmenu->messages[8]->visible=true;
								     shopmenu->button_clicked[1]=false;
							 }
							 else
							 {
							    sprintf(buf2,"* * .**** ");
							    shopmenu->messages[8]->set_text(buf2);
								shopmenu->messages[8]->visible=true;
								shopmenu->button_clicked[1]=false;
							 }
						}
						else if(shopmenu->button_clicked[2]==true)
						{
							 if(GAME->player->points>=pow(4,(GAME->player->bomb_speeder+1))*10)
							 {
									 GAME->player->points-=pow(4,(GAME->player->bomb_speeder+1))*10;
									 GAME->player->bomb_speeder++;
									 sprintf(buf2," * * !");
									 shopmenu->messages[8]->set_text(buf2);
								     shopmenu->messages[8]->visible=true;
								     shopmenu->button_clicked[2]=false;
							 }
							 else
							 {
							    sprintf(buf2,"* * .**** ");
							    shopmenu->messages[8]->set_text(buf2);
								shopmenu->messages[8]->visible=true;
								shopmenu->button_clicked[2]=false;
							 }
						}
						else if(shopmenu->button_clicked[3]==true)
						{
							 if(GAME->player->points>=500)
							 {
									 GAME->player->points-=500;
									 GAME->player->up++;
									 sprintf(buf2," ** !");
									 shopmenu->messages[8]->set_text(buf2);
								     shopmenu->messages[8]->visible=true;
								     shopmenu->button_clicked[3]=false;
							 }
							 else
							 {
							    sprintf(buf2,"* * .**** ");
							    shopmenu->messages[8]->set_text(buf2);
								shopmenu->messages[8]->visible=true;
								shopmenu->button_clicked[3]=false;
							 }
						}
						else if(shopmenu->button_clicked[4]==true)
						{
							 if(GAME->player->points>=400)
							 {
									 GAME->player->points-=400;
									 GAME->player->stop++;
									 sprintf(buf2," **** !");
									 shopmenu->messages[8]->set_text(buf2);
								     shopmenu->messages[8]->visible=true;
								     shopmenu->button_clicked[4]=false;
							 }
							 else
							 {
							    sprintf(buf2,"* * .**** ");
							    shopmenu->messages[8]->set_text(buf2);
								shopmenu->messages[8]->visible=true;
								shopmenu->button_clicked[4]=false;
							 }
						}
						else if(shopmenu->button_clicked[5]==true)
						{
							 if(GAME->player->points>=400)
							 {
									 GAME->player->points-=400;
									 GAME->player->slow++;
									 sprintf(buf2," ***!");
									 shopmenu->messages[8]->set_text(buf2);
								     shopmenu->messages[8]->visible=true;
								     shopmenu->button_clicked[5]=false;
							 }
							 else
							 {
							    sprintf(buf2,"* * .**** ");
							    shopmenu->messages[8]->set_text(buf2);
								shopmenu->messages[8]->visible=true;
								shopmenu->button_clicked[5]=false;
							 }
						}
					 }


				 }
				 else if(menunum==5)
				 {
					 if(optionsmenu->button_clicked[0]==true)
					 {
						 GAME->building_density=optionsmenu->sliders[0]->get_value(true);
						 fil2=fopen("grf.cfg","wb");
						 a=fullscreen;
						 b=soundenabled;
						 fprintf(fil2,"%lf %lf %.0lf %d %d",optionsmenu->sliders[0]->get_value(true),optionsmenu->sliders[1]->get_value(true),optionsmenu->sliders[1]->get_value(true),a,b);
						 fclose(fil2);
						 GAME->load_conf("grf.cfg");
						 menunum=0;
						 mouse[1]=false;
					 }
					 if(optionsmenu->button_clicked[2]==true)
					 {
						 fullscreen=!fullscreen;
						 optionsmenu->button_clicked[2]=false;
						 mouse[1]=false;
						 optionsmenu->buttons[2]->clicked=false;
					 }
					 if(optionsmenu->button_clicked[3]==true)
					 {
						 soundenabled=!soundenabled;
						 optionsmenu->button_clicked[3]=false;
						 mouse[1]=false;
						 optionsmenu->buttons[3]->clicked=false;
					 }
					 if(optionsmenu->button_clicked[1]==true)
					 {
						 menunum=0;
						 mouse[1]=false;
					 }

				 }

			}
		
	
        }

}